/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008,2011          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef _llrapi_h__
#define _llrapi_h__
/*========================================================================*/
/*                                                                        */
/* Module: llrapi.h                                                       */
/*                                                                        */
/*========================================================================*/
/* Do not remove the following line! Required for SCCS. */
/* static char sccsid[] = "@(#) src/ll/h/llrapi.h, includes, comm_rrur2, rrur2s005a 1.34.1.3 6/13/11 03:20:07"; */

#include <stdio.h>
#include <stdint.h>
#include <sys/types.h>

#define LLR_API_VERSION 410	/* use to keep track of the version */
/* of the api code is compiled with */

typedef enum llr_data_specification {

	/* Job object data */
	LLR_JobID = 200,                /* char ** : job ID                */
	LLR_JobName,                    /* char ** : job name              */
	LLR_JobCredential,              /* llr_element_t * (Credential): credentials */
	LLR_JobMode,                    /* llr_job_step_type_t * : batch or interactive */
	LLR_JobSubmitHost,              /* char ** : host job was submitted from  */
	LLR_JobJobQueueKey,             /* int *   : key used to write job to spool */
	LLR_JobJobManager,              /* char ** : Job Manager daemon (schedd) managing the job      */
	LLR_JobSubmitTime,              /* time_t  : time job was queued          */
	LLR_JobVersionNum,              /* int *   : job version number           */
	LLR_JobStepCount,               /* int *   : number of steps in job       */
	LLR_JobGetStepList,             /* llr_data_list_t * : step iterator */
	LLR_JobGetFirstStep,            /* llr_element_t * (Step) : first step       */
	LLR_JobGetNextStep,             /* llr_element_t * (Step) : next step        */

	/* Step object data */
	LLR_StepID = 400,               /* char ** : resource manager job step id */
	LLR_StepNodeCount,              /* int * : number of nodes in step	*/
	LLR_StepGetNodeList,            /* llr_data_list_t * : node iterator */
	LLR_StepGetFirstNode,           /* llr_element_t * (Node) : first node	*/
	LLR_StepGetNextNode,            /* llr_element_t * (Node) : next node	*/
	LLR_StepGetAdapterReqList,      /* llr_data_list_t * : adapter req iterator */
	LLR_StepGetFirstAdapterReq,     /* llr_element_t*(AdapterReq):first AdapterReq */
	LLR_StepGetNextAdapterReq,      /* llr_element_t*(AdapterReq):next AdapterReq */
	LLR_StepMachineCount,           /* int * : number of machines assigned 	*/
	LLR_StepGetMachineList,         /* llr_data_list_t * : machine iterator */
	LLR_StepGetFirstMachine,        /* llr_element_t * (LlMachine): first machine*/
	LLR_StepGetNextMachine,         /* llr_element_t * (LlMachine): next machine */
	LLR_StepGetMasterTask,          /* llr_element_t * (Task): master task on step */
	LLR_StepAccountNumber,          /* char ** : associated account number   */
	LLR_StepComment,                /* char ** : user defined comment	*/
	LLR_StepCompletionCode,         /* int * : exit status 			*/
	LLR_StepCompletionDate,         /* time_t * : UNIX time step was completed */
	LLR_StepEnvironment,            /* char ** : environment			*/
	LLR_StepErrorFile,              /* char ** : name of error file 		*/
	LLR_StepExecSize,               /* int * : size of the master executable */
	LLR_StepImageSize,              /* int * : size of the virtual image in K */
	LLR_StepImageSize64,            /* int64_t * : size of the virtual image in K */
	LLR_StepInputFile,              /* char ** : name of input file 		*/
	LLR_StepIwd,                    /* char ** : initial directory 		*/
	LLR_StepJobClass,               /* char ** : defined class for step 	*/
	LLR_StepName,                   /* char ** : name assigned to step 	*/
	LLR_StepNodeUsage,              /* int * : requested node usage 	*/
	LLR_StepOutputFile,             /* char ** : name of output file 	*/
	LLR_StepParallelMode,           /* int * : mode of the step  		*/
	LLR_StepShell,                  /* char ** : shell to be used 		*/
	LLR_StepStartCount,             /* int * : times step has been started 	*/
	LLR_StepStartDate,              /* time_t * : date step was started 	*/
	LLR_StepStartTime,              /* time_t *: time the starter process for the job step started  */
	LLR_StepDispatchTime,           /* time_t * : time step was dispatched 	*/
	LLR_StepTaskInstanceCount,      /* int * : number of task instances	*/
	LLR_StepCpuLimitHard,           /* int * : cpu hard limit		*/
	LLR_StepCpuLimitHard64,         /* int64_t * : cpu hard limit		*/
	LLR_StepCpuLimitSoft,           /* int * : cpu soft limit		*/
	LLR_StepCpuLimitSoft64,         /* int64_t * : cpu soft limit		*/
	LLR_StepDataLimitHard,          /* int * : data hard limit 		*/
	LLR_StepDataLimitHard64,        /* int64_t * : data hard limit 	*/
	LLR_StepDataLimitSoft,          /* int * : data soft limit 		*/
	LLR_StepDataLimitSoft64,        /* int64_t * : data soft limit 	*/
	LLR_StepAsLimitHard64,          /* int64_t * : as hard limit         */
	LLR_StepAsLimitSoft64,          /* int64_t * : as soft limit         */
	LLR_StepNprocLimitHard64,       /* int64_t * : nproc hard limit      */
	LLR_StepNprocLimitSoft64,       /* int64_t * : nproc soft limit      */
	LLR_StepMemlockLimitHard64,     /* int64_t * : memlock hard limit    */
	LLR_StepMemlockLimitSoft64,     /* int64_t * : memlock soft limit    */
	LLR_StepLocksLimitHard64,       /* int64_t * : locks hard limit      */
	LLR_StepLocksLimitSoft64,       /* int64_t * : locks soft limit      */
	LLR_StepNofileLimitHard64,      /* int64_t * : nofile hard limit     */
	LLR_StepNofileLimitSoft64,      /* int64_t * : nofile soft limit     */
	LLR_StepCoreLimitSoft,          /* int * : core file soft limit		*/
	LLR_StepCoreLimitSoft64,        /* int64_t * : core file soft limit	*/
	LLR_StepCoreLimitHard,          /* int * : core file hard limit 	*/
	LLR_StepCoreLimitHard64,        /* int64_t * : core file hard limit 	*/
	LLR_StepFileLimitHard,          /* int * : file size hard limit		*/
	LLR_StepFileLimitHard64,        /* int64_t * : file size hard limit	*/
	LLR_StepFileLimitSoft,          /* int * : file size soft limit		*/
	LLR_StepFileLimitSoft64,        /* int64_t * : file size soft limit	*/
	LLR_StepRssLimitHard,           /* int * : resident set size hard limit */
	LLR_StepRssLimitHard64,         /* int64_t*: resident set size hard limit */
	LLR_StepRssLimitSoft,           /* int * : resident set size soft limit */
	LLR_StepRssLimitSoft64,         /* int64_t*: resident set size soft limit */
	LLR_StepStackLimitHard,         /* int * : stack size hard limit	*/
	LLR_StepStackLimitHard64,       /* int64_t * : stack size hard limit	*/
	LLR_StepStackLimitSoft,         /* int * : stack size soft limit	*/
	LLR_StepStackLimitSoft64,       /* int64_t * : stack size soft limit	*/
	LLR_StepCpuStepLimitHard,       /* int * : cpu hard limit for entire job */
	LLR_StepCpuStepLimitHard64,     /* int64_t*: cpu hard limit for entire job */
	LLR_StepCpuStepLimitSoft,       /* int * : cpu soft limit for entire job */
	LLR_StepCpuStepLimitSoft64,     /* int64_t*: cpu soft limit for entire job */
	LLR_StepWallClockLimitHard,     /* int * : wall clock hard limit 	*/
	LLR_StepWallClockLimitHard64,   /* int64_t * : wall clock hard limit*/
	LLR_StepWallClockLimitSoft,     /* int * : wall clock soft limit 	*/
	LLR_StepWallClockLimitSoft64,   /* int64_t * : wall clock soft limit*/
	LLR_StepState,                  /* int * : current state of the step	*/
	LLR_StepHostList,               /* char *** : hosts in host.list file */
	LLR_StepLoadLevelerGroup,       /* char ** : LL group specified by step  */
	LLR_StepTaskGeometry,           /* char ** : task geometry requested */
	LLR_StepTotalNodesRequested,    /* char ** : total nodes requested */
	LLR_StepRestart,                /* bool * : is step restartable */
	LLR_StepTotalTasksRequested,    /* int * : total tasks requested */
	LLR_StepTasksPerNodeRequested,  /* int * : tasks per node requested */
	LLR_StepBlocking,               /* int * : blocking factor requested */
	LLR_StepStepUserTime64,         /* int64_t * : step user time - microseconds */
	LLR_StepStepSystemTime64,       /* int64_t*: step system time - microseconds */
	LLR_StepStepMaxrss64,           /* int64_t * : step ru_maxrss */
	LLR_StepStepIxrss64,            /* int64_t * : step ru_ixrss */
	LLR_StepStepIdrss64,            /* int64_t * : step ru_idrss */
	LLR_StepStepIsrss64,            /* int64_t * : step ru_isrss */
	LLR_StepStepMinflt64,           /* int64_t * : step ru_minflt */
	LLR_StepStepMajflt64,           /* int64_t * : step ru_majflt */
	LLR_StepStepNswap64,            /* int64_t * : step ru_nswap */
	LLR_StepStepInblock64,          /* int64_t * : step ru_inblock */
	LLR_StepStepOublock64,          /* int64_t * : step ru_oublock */
	LLR_StepStepMsgsnd64,           /* int64_t * : step ru_msgsnd */
	LLR_StepStepMsgrcv64,           /* int64_t * : step ru_msgrcv */
	LLR_StepStepNsignals64,         /* int64_t * : step ru_nsignals */
	LLR_StepStepNvcsw64,            /* int64_t * : step ru_nvcsw */
	LLR_StepStepNivcsw64,           /* int64_t * : step ru_nivcsw */
	LLR_StepStarterUserTime64,      /* int64_t*: starter user time-microseconds */
	LLR_StepStarterSystemTime64,    /* int64_t*: starter system time-microseconds */
	LLR_StepStarterMaxrss64,        /* int64_t * : starter ru_maxrss */
	LLR_StepStarterIxrss64,         /* int64_t * : starter ru_ixrss */
	LLR_StepStarterIdrss64,         /* int64_t * : starter ru_idrss */
	LLR_StepStarterIsrss64,         /* int64_t * : starter ru_isrss */
	LLR_StepStarterMinflt64,        /* int64_t * : starter ru_minflt */
	LLR_StepStarterMajflt64,        /* int64_t * : starter ru_majflt */
	LLR_StepStarterNswap64,         /* int64_t * : starter ru_nswap */
	LLR_StepStarterInblock64,       /* int64_t * : starter ru_inblock */
	LLR_StepStarterOublock64,       /* int64_t * : starter ru_oublock */
	LLR_StepStarterMsgsnd64,        /* int64_t * : starter ru_msgsnd */
	LLR_StepStarterMsgrcv64,        /* int64_t * : starter ru_msgrcv */
	LLR_StepStarterNsignals64,      /* int64_t * : starter ru_nsignals */
	LLR_StepStarterNvcsw64,         /* int64_t * : starter ru_nvcsw */
	LLR_StepStarterNivcsw64,        /* int64_t * : starter ru_nivcsw */
	LLR_StepMachUsageCount,         /* int * : count of machine usages */
	LLR_StepGetMachUsageList,       /* llr_data_list_t * : machine usage iterator */
	LLR_StepGetFirstMachUsage,      /* llr_element_t * (MachineUsage): first machine usage */
	LLR_StepGetNextMachUsage,       /* llr_element_t * (MachineUsage): next machine usage */
	LLR_StepCheckpointable,         /* bool * : is step checkpointable   */
	LLR_StepCheckpointing,          /* bool * : is step being checkpointed */
	LLR_StepCkptAccumTime,          /* int * : accumulated ckpt time */
	LLR_StepCkptFailStartTime,      /* time_t * : time of last failed ckpt*/
	LLR_StepCkptFile,               /* char ** : name of ckpt file */
	LLR_StepCkptSubDir,             /* char ** : name of ckpt_subdir file */
	LLR_StepCkptGoodElapseTime,     /* int * : time taken to complete last good ckpt */
	LLR_StepCkptGoodStartTime,      /* time_t * : time of last good ckpt */
	LLR_StepCkptTimeHardLimit,      /* int * : ckpt time hard limit */
	LLR_StepCkptTimeHardLimit64,    /* int64_t * : ckpt time hard limit */
	LLR_StepCkptTimeSoftLimit,      /* int * : ckpt time soft limit */
	LLR_StepCkptTimeSoftLimit64,    /* int64_t * : ckpt time soft limit */
	LLR_StepCkptRestart,            /* bool * : was step restarted from a checkpoint */
	LLR_StepCkptRestartSameNodes,   /* bool * : restart step on same nodes */
	LLR_StepWallClockUsed,          /* int * : wallclock already used by the step */
	LLR_StepLargePage,              /* char ** : Large Page requirement (= "M", "Y", or "N") */
	LLR_StepMaxProtocolInstances,   /* int * : largest number of instances allowed on network stmt */
	LLR_StepBulkXfer,		            /* bool * : is step requesting bulk transfer */
	LLR_StepTotalRcxtBlocks,	      /* int * : total number of RCXT blocks step needs */
	LLR_StepUserRcxtBlocks,	        /* int * : number of user RCXT blocks step requests */
	LLR_StepPreemptable,            /* bool * : is step preemptable */
	LLR_StepRsetName,               /* char ** rset name */
	LLR_StepMcmAffinityOptions,     /* char ** mcm affinity options */
	LLR_StepTaskAffinity,           /* char** : task affinity request    */
	LLR_StepCpusPerCore,            /* int * : cpus per core             */
	LLR_StepCkptExecuteDirectory,   /* char ** : Executable directory for a checkpointable step */
	LLR_StepMasterVirtualIP,        /* char ** : virtual IP associated with POE process */
	LLR_StepMasterRealIP,           /* char ** : real IP of adapter associated with POE process */
	LLR_StepMasterNetmask,          /* char ** : real netmask of adapter associated with POE process */
	LLR_StepVipNetmask,             /* char ** : vipserver virtual netmask */
	LLR_StepMetaClusterPoeHostname, /* char ** : host name of machine POE is running on */
	LLR_StepMetaClusterJobID,       /* int * : metacluster job ID LoadLeveler has assigned to job step */
	LLR_StepAcctKey,                /* int64_t * : accounting key for step */
	LLR_StepDependency,             /* char ** : Step Dependency */
	LLR_StepBgJobId,                /* char ** : Blue Gene ID for the step */
	LLR_StepBgJobState,             /* int * : Blue Gene state for the step */
	LLR_StepBgConnectionRequested,  /* int * : type of wiring requested for Blue Gene step */
	LLR_StepBgPartitionAllocated,   /* char ** : Blue Gene partition allocated for step */
	LLR_StepBgErrorText,            /* char ** : error text from Blue Gene system for step */
	LLR_StepBgSizeRequested,        /* int * : size requested for Blue Gene step */
	LLR_StepBgShapeRequested,       /* int ** : shape requested for Blue Gene step */
	LLR_StepBgPartitionType,		    /* int * : Blue Gene partition type */
	LLR_StepCoschedule,             /* bool * : 0|1 coschedule option */
	LLR_StepSMTRequired,            /* llr_smt_required_state_t * : required SMT state */
	LLR_StepGetNetworkUsageList,    /* llr_data_list_t * : resource iterator */
	LLR_StepGetFirstNetworkUsage,	  /* llr_element_t * : First element in the network list */
	LLR_StepGetNextNetworkUsage,	  /* llr_element_t * : Next element in the network list */

	RESERVED_LLR_Step1,             /* reserved */
	RESERVED_LLR_Step2,             /* reserved */
	LLR_StepEligibilityTime,         /* time_t * : time step became eligible for dispatch */
	/* Machine object data */
	LLR_MachineArchitecture = 800,/* char ** : machine architecture	*/
	LLR_MachineDisk,              /* int * : avail space (KB) in execute dir */
	LLR_MachineDisk64,            /* int64_t * : avail space (KB) in execute dir */
	LLR_MachineName,              /* char ** : official hostname 		*/
	LLR_MachineTimeStamp,         /* time_t *: time when machine data received */
	LLR_MachineVirtualMemory,     /* int * : available swap space in kilobytes */
	LLR_MachineVirtualMemory64,   /* int64_t * : available swap space in Kb */
	LLR_MachineRealMemory,        /* int * : physical memory 		*/
	LLR_MachineRealMemory64,      /* int64_t * : physical memory 		*/
	LLR_MachineSpeed,             /* double * : speed associated with machine */
	LLR_MachineMaxTasks,          /* int * : max number of tasks allowed 	*/
	LLR_MachinePrestartedStarters,/* int * : Prestarted Starters to be started */
	LLR_MachineMachineMode,       /* char ** : configured machine mode 	*/
	LLR_MachinePoolList,          /* int ** : list of configured pools */
	LLR_MachinePoolListSize,      /* int * : number of configured pools   */
	LLR_MachineScheddState,       /* int * : schedd state			*/
	LLR_MachineConfiguredClassList,/* char ***: initiators defined */
	LLR_MachineFeatureList,       /* char *** : features defined	*/
	LLR_MachineOperatingSystem,   /* char ** : machine operating system */
	LLR_MachineLoadAverage,       /* double * : load average 		*/
	LLR_MachineFreeRealMemory,    /* int * : free real memory in Mbytes */
	LLR_MachineFreeRealMemory64,  /* int64_t * : free real memory in Mbytes */
	LLR_MachinePagesScanned,      /* int * : pages scanned/sec by page replacement algorithm */
	LLR_MachinePagesScanned64,    /* int64_t * : pages scanned/sec by page replacement algorithm */
	LLR_MachinePagesFreed,        /* int * : pages freed/sec by page replacement algorithm */
	LLR_MachinePagesFreed64,      /* int64_t * : pages freed/sec by page replacement algorithm */
	LLR_MachinePagesPagedIn,      /* int * : pages paged in from paging space */
	LLR_MachinePagesPagedIn64,    /* int64_t*:pages paged in from paging space*/
	LLR_MachinePagesPagedOut,     /* int * : pages paged out to paging space  */
	LLR_MachinePagesPagedOut64,   /* int64_t*:pages paged out to paging space*/
	LLR_MachineGetResourceList,   /* llr_data_list_t * : resource iterator */
	LLR_MachineGetFirstResource,  /* llr_element_t * (Resource):first resource */
	LLR_MachineGetNextResource,   /* llr_element_t * (Resource):next  resource */
	LLR_MachineCPUs,              /* int * : number of cpus		*/
	LLR_MachineCPUList,           /* int ** : list of cpus */
	LLR_MachineStartdState,       /* char ** : startd state		*/
	LLR_MachineScheddRunningJobs, /* int * : running jobs assigned schedd */
	LLR_MachineScheddTotalJobs,   /* int * : total jobs assigned schedd */
	LLR_MachineStartdRunningJobs, /* int * : running jobs assigned startd */
	LLR_MachineKbddIdle,          /* int * : seconds kbdd is idle  	*/
	LLR_MachineGetAdapterList,    /* llr_data_list_t * : adapter iterator */
	LLR_MachineGetFirstAdapter,   /* llr_element_t * (Adapter): first adapter */
	LLR_MachineGetNextAdapter,    /* llr_element_t * (Adapter): next adapter  */
	LLR_MachineGetMCMList,        /* llr_data_list_t * : mcm iterator */
	LLR_MachineGetFirstMCM,       /* llr_element_t * (MCM): first mcm */
	LLR_MachineGetNextMCM,        /* llr_element_t * (MCM): next mcm  */

	LLR_MachineStartExpr,         /* char ** : START expression */
	LLR_MachineSuspendExpr,       /* char ** : SUSPEND expression */
	LLR_MachineContinueExpr,      /* char ** : CONTINUE expression */
	LLR_MachineVacateExpr,        /* char ** : VACATE expression */
	LLR_MachineKillExpr,          /* char ** : KILL expression */
	LLR_MachineLargePageSize64,   /* int64_t * : size of large page memory block (bytes) */
	LLR_MachineLargePageCount64,  /* int64_t * : total number of large page memory blocks */
	LLR_MachineLargePageFree64,   /* int64_t * : number of large page memory blocks on freelist */
	LLR_MachineConfigTimeStamp,   /* time_t * : time of last reconfig */
	LLR_MachineRSetSupport,       /* llr_affinity_support_t * : type of affinity support configured */
	LLR_MachineSMTState,          /* llr_smt_state_t * : SMT state of the machine */
	LLR_MachineMaxDstgStarters,   /* int * : max number of data staging tasks allowed */

	/* MCM object data */
	LLR_MCMID = 1000,					  	/* int *  : MCM id */
	LLR_MCMCPUs,				          /* int *  : count of CPUs on the MCM */
	LLR_MCMCPUList,					      /* int ** : list of CPUs on the MCM  */

	/* Node object data */
	LLR_NodeTaskCount=1100,      /* int * : number of task instances	*/
	LLR_NodeGetTaskList,         /* llr_data_list_t * : task iterator */
	LLR_NodeGetFirstTask,        /* llr_element_t * (Task) : first task	*/
	LLR_NodeGetNextTask,         /* llr_element_t * (Task) : next task 	*/
	LLR_NodeMaxInstances,        /* int * : maximum # requested nodes    */
	LLR_NodeMinInstances,        /* int * : minimum # requested nodes    */
	LLR_NodeRequirements,        /* char ** : defined requirements 	*/
	LLR_NodeInitiatorCount,      /* int * : initiator count      	*/
	LLR_NodeGetResourceRequirementList,  /* llr_data_list_t * : resource requirement iterator */
	LLR_NodeGetFirstResourceRequirement, /* llr_element_t * (ResourceReq) */
	LLR_NodeGetNextResourceRequirement,  /* llr_element_t * (ResourceReq) */

	/* Task object data */
	LLR_TaskTaskInstanceCount=1300,      /* int * : number of task instances*/
	LLR_TaskGetTaskInstanceList,         /* llr_data_list_t * : task instance iterator */
	LLR_TaskGetFirstTaskInstance,        /* llr_element_t * (TaskInstance)	*/
	LLR_TaskGetNextTaskInstance,         /* llr_element_t * (TaskInstance)	*/
	LLR_TaskExecutable,                  /* char ** : executable 		*/
	LLR_TaskExecutableArguments,         /* char ** : executable arguments	*/
	LLR_TaskIsMaster,                    /* int * : boolean, is this the master task */
	LLR_TaskGetResourceRequirementList,  /* llr_data_list_t * : resource requirement iterator */
	LLR_TaskGetFirstResourceRequirement, /* llr_element_t * (ResourceReq) */
	LLR_TaskGetNextResourceRequirement,  /* llr_element_t * (ResourceReq) */

	/* Task Instance object data */
	LLR_TaskInstanceMachineName=1600,     /*  char ** : machine assigned   */
	LLR_TaskInstanceMachineAddress,       /*  char ** : machine IP address */
	LLR_TaskInstanceMachine,              /*  llr_element_t * (LlMachine): machine Object */
	LLR_TaskInstanceTaskID,               /*  int * : task id	 	*/
	LLR_TaskInstanceCpuList,              /* int *  : cpus used by task */
	LLR_TaskInstanceMachineVirtualIP,     /* char ** : virtual IP associated PMD process */

	/* Adapter object data */
	LLR_AdapterName = 1500,              /* char ** : adapter name		*/
	LLR_AdapterInterfaceAddress,         /* char ** : interface IP address*/
	LLR_AdapterInterfaceNetmask,         /* char ** : netmask of adapter */
	LLR_AdapterMinWindowSize64,          /* uint64_t * : min allocatable window memory */
	LLR_AdapterMaxWindowSize64,          /* uint64_t * : max allocatable window memory */
	LLR_AdapterMemory64,                 /* uint64_t * : total adapter memory		*/
	LLR_AdapterTotalWindowCount,         /* int * : # of windows on adapter  */
	LLR_AdapterMCMId,						         /* int * : mcm this adpter connected to */
	LLR_AdapterPortNumber,               /* int *: port number of adapter */
	LLR_AdapterLmc,                      /* int *: logical mask of adapter */
	LLR_AdapterNetworkId,                /* uint64_t *: network id of adapter  */
	LLR_AdapterNetworkType,              /* int *: adapter network type (llr_network_type) */
	LLR_AdapterGetManagedAdapterList,    /* llr_data_list_t * : managed adapter iterator */
	LLR_AdapterGetFirstManagedAdapter,   /* llr_element_t * (Adapter)	*/
	LLR_AdapterGetNextManagedAdapter,    /* llr_element_t * (Adapter)	*/
	LLR_AdapterConfigStatus,             /* int * : adapter config status (llr_adapter_state_t)*/
	LLR_AdapterConnectionStatus,         /* int * : adapter connection status (llr_adapter_state_t)*/
	LLR_AdapterHeartbeatStatus,          /* int * : adapter heart beat status (llr_heartbeat_status_t)*/


	/* AdapterReq object data */
	LLR_AdapterReqUsage = 1700,         /* int * : requested adapter usage */
	LLR_AdapterReqCommLevel,            /* int * : communication level      */
	LLR_AdapterReqInstances,            /* int * : requested number of instances for protocol */
	LLR_AdapterReqRcxtBlks,             /* int * : requested number of user rCxt Blocks for protocol */
	LLR_AdapterReqProtocol,             /* char ** : requested adapter protocol */
	LLR_AdapterReqMode,                 /* char ** : requested adapter mode */
	LLR_AdapterReqTypeName,             /* char ** : requested adapter type */

	/* Credential object data */
	LLR_CredentialUid = 1900,           /* int * : unix user id of submitter 	*/
	LLR_CredentialGid,                  /* int * : unix group id of submitter	*/
	LLR_CredentialUserName,             /* char ** : user name of submitter   */
	LLR_CredentialGroupName,            /* char ** : group name of submitter  */

	/* Resource object data */
	LLR_ResourceName=2000,             /* char ** : resource name          */
	LLR_ResourceInitialValue,          /* int * : # of initial resources   */
	LLR_ResourceInitialValue64,        /* int64_t * # of initial resources */
	LLR_ResourceAvailableValue,        /* int * : # of available resources */

	/* ResourceReq object data */
	LLR_ResourceRequirementName=2200,  /* char **: job's resource requirement */
	LLR_ResourceRequirementValue,      /* int  *: # of resources requested    */
	LLR_ResourceRequirementValue64,    /* int64_t*:  # of resources requested */

	/* MachineUsage object data */
	LLR_MachUsageMachineName = 2400,   /* char **: machine name  */
	LLR_MachUsageMachineSpeed,         /* double *: machine speed */
	LLR_MachUsageDispUsageCount,       /* int *: number of dispatch usages  */
	LLR_MachUsageGetDispUsageList,     /* llr_data_list_t * : dispatch usage iterator */
	LLR_MachUsageGetFirstDispUsage,    /* llr_element_t * (DispUsage): first dispatch usage */
	LLR_MachUsageGetNextDispUsage,     /* llr_element_t * (DispUsage): next  dispatch usage */


	/* DispatchUsage object data */
	LLR_DispUsageEventUsageCount=2600, /* int  *: number of event usages */
	LLR_DispUsageGetEventUsageList,    /* llr_data_list_t * : event usage iterator */
	LLR_DispUsageGetFirstEventUsage,   /* llr_element_t * (EventUsage): first event usage */
	LLR_DispUsageGetNextEventUsage,    /* llr_element_t * (EventUsage): next  event usage */
	LLR_DispUsageStepUserTime64,       /* int64_t * : dispatch usage step user time - microseconds */
	LLR_DispUsageStepSystemTime64,     /* int64_t * : dispatch usage step system time - microseconds */
	LLR_DispUsageStepMaxrss64,         /* int64_t * : dispatch usage step ru_maxrss */
	LLR_DispUsageStepIxrss64,          /* int64_t * : dispatch usage step ru_ixrss */
	LLR_DispUsageStepIdrss64,          /* int64_t * : dispatch usage step ru_idrss */
	LLR_DispUsageStepIsrss64,          /* int64_t * : dispatch usage step ru_isrss */
	LLR_DispUsageStepMinflt64,         /* int64_t * : dispatch usage step ru_minflt */
	LLR_DispUsageStepMajflt64,         /* int64_t * : dispatch usage step ru_majflt */
	LLR_DispUsageStepNswap64,          /* int64_t * : dispatch usage step ru_nswap */
	LLR_DispUsageStepInblock64,        /* int64_t * : dispatch usage step ru_inblock */
	LLR_DispUsageStepOublock64,        /* int64_t * : dispatch usage step ru_oublock */
	LLR_DispUsageStepMsgsnd64,         /* int64_t * : dispatch usage step ru_msgsnd */
	LLR_DispUsageStepMsgrcv64,         /* int64_t * : dispatch usage step ru_msgrcv */
	LLR_DispUsageStepNsignals64,       /* int64_t * : dispatch usage step ru_nsignals */
	LLR_DispUsageStepNvcsw64,          /* int64_t * : dispatch usage step ru_nvcsw */
	LLR_DispUsageStepNivcsw64,         /* int64_t * : dispatch usage step ru_nivcsw */
	LLR_DispUsageStarterUserTime64,    /* int64_t * : dispatch usage starter user time - microseconds */
	LLR_DispUsageStarterSystemTime64,  /* int64_t * : dispatch usage starter system time - microseconds */
	LLR_DispUsageStarterMaxrss64,      /* int64_t * : dispatch usage starter ru_maxrss */
	LLR_DispUsageStarterIxrss64,       /* int64_t * : dispatch usage starter ru_ixrss */
	LLR_DispUsageStarterIdrss64,       /* int64_t * : dispatch usage starter ru_idrss */
	LLR_DispUsageStarterIsrss64,       /* int64_t * : dispatch usage starter ru_isrss */
	LLR_DispUsageStarterMinflt64,      /* int64_t * : dispatch usage starter ru_minflt */
	LLR_DispUsageStarterMajflt64,      /* int64_t * : dispatch usage starter ru_majflt */
	LLR_DispUsageStarterNswap64,       /* int64_t * : dispatch usage starter ru_nswap */
	LLR_DispUsageStarterInblock64,     /* int64_t * : dispatch usage starter ru_inblock */
	LLR_DispUsageStarterOublock64,     /* int64_t * : dispatch usage starter ru_oublock */
	LLR_DispUsageStarterMsgsnd64,      /* int64_t * : dispatch usage starter ru_msgsnd */
	LLR_DispUsageStarterMsgrcv64,      /* int64_t * : dispatch usage starter ru_msgrcv */
	LLR_DispUsageStarterNsignals64,    /* int64_t * : dispatch usage starter ru_nsignals */
	LLR_DispUsageStarterNvcsw64,       /* int64_t * : dispatch usage starter ru_nvcsw */
	LLR_DispUsageStarterNivcsw64,      /* int64_t * : dispatch usage starter ru_nivcsw */

	/* EventUsage object data */
	LLR_EventUsageEventID = 3000,      /* int * : event id */
	LLR_EventUsageEventName,           /* char **  event name */
	LLR_EventUsageEventTimestamp,      /* time_t *  time event occured */
	LLR_EventUsageStepUserTime64,      /* int64_t * : event usage step user time - microseconds */
	LLR_EventUsageStepSystemTime64,    /* int64_t * : event usage step system time - microseconds */
	LLR_EventUsageStepMaxrss64,        /* int64_t * : event usage step ru_maxrss */
	LLR_EventUsageStepIxrss64,         /* int64_t * : event usage step ru_ixrss */
	LLR_EventUsageStepIdrss64,         /* int64_t * : event usage step ru_idrss */
	LLR_EventUsageStepIsrss64,         /* int64_t * : event usage step ru_isrss */
	LLR_EventUsageStepMinflt64,        /* int64_t * : event usage step ru_minflt */
	LLR_EventUsageStepMajflt64,        /* int64_t * : event usage step ru_majflt */
	LLR_EventUsageStepNswap64,         /* int64_t * : event usage step ru_nswap */
	LLR_EventUsageStepInblock64,       /* int64_t * : event usage step ru_inblock */
	LLR_EventUsageStepOublock64,       /* int64_t * : event usage step ru_oublock */
	LLR_EventUsageStepMsgsnd64,        /* int64_t * : event usage step ru_msgsnd */
	LLR_EventUsageStepMsgrcv64,        /* int64_t * : event usage step ru_msgrcv */
	LLR_EventUsageStepNsignals64,      /* int64_t * : event usage step ru_nsignals */
	LLR_EventUsageStepNvcsw64,         /* int64_t * : event usage step ru_nvcsw */
	LLR_EventUsageStepNivcsw64,        /* int64_t * : event usage step ru_nivcsw */
	LLR_EventUsageStarterUserTime64,   /* int64_t * : event usage starter user time - microseconds */
	LLR_EventUsageStarterSystemTime64, /* int64_t * : event usage starter system time - microseconds */
	LLR_EventUsageStarterMaxrss64,     /* int64_t * : event usage starter ru_maxrss */
	LLR_EventUsageStarterIxrss64,      /* int64_t * : event usage starter ru_ixrss */
	LLR_EventUsageStarterIdrss64,      /* int64_t * : event usage starter ru_idrss */
	LLR_EventUsageStarterIsrss64,      /* int64_t * : event usage starter ru_isrss */
	LLR_EventUsageStarterMinflt64,     /* int64_t * : event usage starter ru_minflt */
	LLR_EventUsageStarterMajflt64,     /* int64_t * : event usage starter ru_majflt */
	LLR_EventUsageStarterNswap64,      /* int64_t * : event usage starter ru_nswap */
	LLR_EventUsageStarterInblock64,    /* int64_t * : event usage starter ru_inblock */
	LLR_EventUsageStarterOublock64,    /* int64_t * : event usage starter ru_oublock */
	LLR_EventUsageStarterMsgsnd64,     /* int64_t * : event usage starter ru_msgsnd */
	LLR_EventUsageStarterMsgrcv64,     /* int64_t * : event usage starter ru_msgrcv */
	LLR_EventUsageStarterNsignals64,   /* int64_t * : event usage starter ru_nsignals */
	LLR_EventUsageStarterNvcsw64,      /* int64_t * : event usage starter ru_nvcsw */
	LLR_EventUsageStarterNivcsw64,     /* int64_t * : event usage starter ru_nivcsw */

	/* WlmStat object data */
	LLR_WlmStatCpuTotalUsage=3400,     /* int64_t* : WLM reported total cpu usage*/
	LLR_WlmStatCpuSnapshotUsage,       /* int * : WLM snapshot cpu usage      */
	LLR_WlmStatMemorySnapshotUsage,    /* int * : WLM real memory snapshot usage */
	LLR_WlmStatMemoryHighWater,        /* int64_t * : WLM real memory high water */
	LLR_WlmStatVMemorySnapshotUsage,   /* int64_t * : WLM virtual memory usage   */
	LLR_WlmStatVMemoryHighWater,       /* int64_t * : WLM virtual memory high water */
	LLR_WlmStatLargePageMemorySnapshotUsage,/* int* : WLM large page memory usage */

	/* Class object data */
	LLR_ClassName = 3600,              /* char ** : class name */
	LLR_ClassComment,                  /* char ** : class comment */
	LLR_ClassCkptDir,                  /* char ** : directory for checkpoint files */
	LLR_ClassCkptTimeHardLimit,        /* int64_t *: ckpt time hard limit */
	LLR_ClassCkptTimeSoftLimit,        /* int64_t *: ckpt time soft limit */
	LLR_ClassWallClockLimitHard,       /* int64_t *: wall clock hard limit */
	LLR_ClassWallClockLimitSoft,       /* int64_t *: wall clock soft limit */
	LLR_ClassCpuStepLimitHard,         /* int64_t *: Hard Job_cpu_limit */
	LLR_ClassCpuStepLimitSoft,         /* int64_t *: Soft Job_cpu_limit */
	LLR_ClassCpuLimitHard,             /* int64_t *: cpu hard limit */
	LLR_ClassCpuLimitSoft,             /* int64_t *: cpu soft limit */
	LLR_ClassDataLimitHard,            /* int64_t *: data hard limit */
	LLR_ClassDataLimitSoft,            /* int64_t *: data soft limit */
	LLR_ClassAsLimitHard,              /* int64_t *: as hard limit */
	LLR_ClassAsLimitSoft,              /* int64_t *: as soft limit */
	LLR_ClassNprocLimitHard,           /* int64_t *: nproc hard limit */
	LLR_ClassNprocLimitSoft,           /* int64_t *: nproc soft limit */
	LLR_ClassMemlockLimitHard,         /* int64_t *: memlock hard limit */
	LLR_ClassMemlockLimitSoft,         /* int64_t *: memlock soft limit */
	LLR_ClassLocksLimitHard,           /* int64_t *: locks hard limit */
	LLR_ClassLocksLimitSoft,           /* int64_t *: locks soft limit */
	LLR_ClassNofileLimitHard,          /* int64_t *: nofile hard limit */
	LLR_ClassNofileLimitSoft,          /* int64_t *: nofile soft limit */
	LLR_ClassCoreLimitHard,            /* int64_t *: core file hard limit */
	LLR_ClassCoreLimitSoft,            /* int64_t *: core file soft limit */
	LLR_ClassFileLimitHard,            /* int64_t *: file size hard limit */
	LLR_ClassFileLimitSoft,            /* int64_t *: file size soft limit */
	LLR_ClassStackLimitHard,           /* int64_t *: stack size hard limit */
	LLR_ClassStackLimitSoft,           /* int64_t *: stack size soft limit */
	LLR_ClassRssLimitHard,             /* int64_t *: resident set size hard limit */
	LLR_ClassRssLimitSoft,             /* int64_t *: resident set size soft limit */
	LLR_ClassMaximumSlots,             /* int * : total number of configured initiators */
	LLR_ClassDefWallClockLimitHard,    /* int64_t *: default wall clock hard limit */
	LLR_ClassDefWallClockLimitSoft,    /* int64_t *: default wall clock soft limit */
	LLR_ClassStripingWithMinimumNetworks, /* bool *: allow striping on nodes with more than half networks in READY state */
	LLR_ClassRestart,		   /* char **: restart */

	/* NetworkUsage data object */
	LLR_NetworkUsageNetworkId = 3800, /* uint64_t * : network ID */
	LLR_NetworkUsageInstances,	      /* int * : number of Instances */
	LLR_NetworkUsageProtocol,	        /* char ** : Names of requested protocol */
	LLR_NetworkUsageMode,		          /* char ** : Names of modeIP or US */
	LLR_NetworkUsageWindows,		      /* int * : window ids count */
	LLR_NetworkUsageRcxtBlocks,	      /* int * : number of rCxt blocks */

} llr_data_specification_t;

typedef enum llr_ret_code {
	LLR_API_OK,
	LLR_API_COMM_ERROR,
	LLR_API_ERROR,
} llr_ret_code_t;

typedef enum llr_job_format {
	LLR_LOADLEVELER_FORMAT,
} llr_job_format_t;

typedef enum llr_job_mode {
	LLR_BATCH_MODE,
	LLR_INTERACTIVE_MODE,
} llr_job_mode_t;

typedef enum llr_job_control_op {
	LLR_CANCEL_OP,
	LLR_VACATE_OP,
	LLR_PREEMPT_OP,
	LLR_PREEMPT_WITHOUT_ADAPTERS_OP,
	LLR_RESUME_OP,
	LLR_IDLE_OP,
	LLR_CKPT_AND_CONTINUE_OP,
	LLR_CKPT_AND_TERMINATE_OP,
	LLR_SIGNAL_OP
} llr_job_control_op_t;

typedef enum llr_job_start_flags {
	LLR_RESERVED_1 = (1<<0)
} llr_job_start_flags_t;

typedef enum llr_event_type {
	LLR_JOB_ADD_EVENT,
	LLR_JOB_DELETE_EVENT,
	LLR_JOB_STEP_STATE_CHANGE_EVENT,
	LLR_MACHINE_CONFIG_EVENT,
	LLR_MACHINE_UPDATE_EVENT,
	LLR_MACHINE_DOWN_EVENT,
	LLR_RESOURCE_MGR_UP_EVENT,
	LLR_RESOURCE_MGR_DOWN_EVENT,
	LLR_JOB_MGR_UP_EVENT,
	LLR_JOB_MGR_DOWN_EVENT,
	LLR_ALL_JOBS_EVENT,
	LLR_ALL_MACHINES_EVENT,
	LLR_JOB_STEP_UPDATE_EVENT,
	LLR_JOB_ID_CHANGE_EVENT,
	LLR_MACHINE_UPDATE_ADAPTER_EVENT
} llr_event_type_t;

typedef enum llr_query_type {
	LLR_REGIONS_QUERY,
	LLR_JOBS_QUERY,
	LLR_MACHINES_QUERY,
	LLR_WLMSTAT_QUERY,
} llr_query_type_t;

typedef enum llr_query_filter_type {
	LLR_QUERY_USER,
	LLR_QUERY_GROUP,
	LLR_QUERY_JOBID,
	LLR_QUERY_STEPID,
	LLR_QUERY_STARTDATE,
	LLR_QUERY_ENDDATE,
	LLR_QUERY_HOST
} llr_query_filter_type_t;

typedef enum llr_query_source {
	LLR_QUERY_RESOURCE_MANAGER,
	LLR_QUERY_STARTD,
	LLR_QUERY_JOBMGR,
	LLR_QUERY_MASTER,
	LLR_QUERY_STARTER,
	LLR_QUERY_HISTORY_FILE
} llr_query_source_t;

typedef enum llr_move_spool_data {
	LLR_MOVE_SPOOL_JOBS
} llr_move_spool_data_t;

typedef enum llr_cluster_auth_op {
	LLR_CLUSTER_AUTH_GENKEY
} llr_cluster_auth_op_t;

typedef enum llr_control_op {
	LLR_CONTROL_RECYCLE,
	LLR_CONTROL_RECONFIG,
	LLR_CONTROL_START,
	LLR_CONTROL_STOP,
	LLR_CONTROL_DRAIN_JOBMGR,
	LLR_CONTROL_RESUME_JOBMGR,
	LLR_CONTROL_DUMP_LOGS
} llr_control_op_t;

typedef enum llr_error_opt {
	LLR_ERROR_PRINT_STDOUT,
	LLR_ERROR_PRINT_STDERR,
	LLR_ERROR_RETURN_STRING,
	LLR_ERROR_FREE
} llr_error_opt_t;

typedef enum llr_job_step_type {
	LLR_BATCH_JOB,
	LLR_INTERACTIVE_JOB
} llr_job_step_type_t;

typedef enum llr_sharing_type {
	LLR_NOT_SHARED,
	LLR_SHARED
} llr_sharing_type_t;

typedef enum llr_parallel_mode {
	LLR_SERIAL_TYPE,
	LLR_PARALLEL_TYPE,
	LLR_BLUE_GENE_TYPE,
	LLR_MPICH_TYPE
} llr_parallel_mode_t;

typedef enum llr_step_state {
	LLR_STATE_CANCELED,
	LLR_STATE_COMPLETED,
	LLR_STATE_COMPLETE_PENDING,
	LLR_STATE_DEFERRED,
	LLR_STATE_HOLD,
	LLR_STATE_IDLE,
	LLR_STATE_NOTQUEUED,
	LLR_STATE_NOTRUN,
	LLR_STATE_PENDING,
	LLR_STATE_PREEMPTED,
	LLR_STATE_PREEMPT_PENDING,
	LLR_STATE_REJECTED,
	LLR_STATE_REJECT_PENDING,
	LLR_STATE_REMOVED,
	LLR_STATE_REMOVE_PENDING,
	LLR_STATE_RESUME_PENDING,
	LLR_STATE_RUNNING,
	LLR_STATE_STARTING,
	LLR_STATE_SUBMISSION_ERR,
	LLR_STATE_TERMINATED,
	LLR_STATE_UNEXPANDED,
	LLR_STATE_VACATED,
	LLR_STATE_VACATE_PENDING,
} llr_step_state_t;

typedef enum llr_smt_required_state {
	LLR_SMT_OFF,
	LLR_SMT_ON,
	LLR_SMT_AS_IS
} llr_smt_required_state_t;

typedef enum llr_smt_state {
	LLR_SMT_DISABLED,
	LLR_SMT_ENABLED,
	LLR_SMT_NOT_SUPPORTED
} llr_smt_state_t;

typedef enum llr_affinity_support {
	LLR_MCM_AFFINITY,
	LLR_USER_DEFINED_RSET,
	LLR_NO_AFFINITY
} llr_affinity_support_t;

typedef enum llr_job_mgr {
	LLR_JOB_MGR_RUNING,
	LLR_JOB_MGR_DRAINED,
	LLR_JOB_MGR_DRAINING,
	LLR_JOB_MGR_FLUSHED,
	LLR_JOB_MGR_FLUSHING,
	LLR_JOB_MGR_DOWN
} llr_job_mgr_state_t;

typedef enum llr_network_mode {
	LLR_IP_MODE,
	LLR_US_MODE
} llr_network_mode_t;

typedef enum llr_network_type {
	LLR_SWITCH_NETWORK,
	LLR_ETHERNET_NETWORK,
	LLR_MULTILINK_NETWORK
} llr_network_type_t;
typedef enum llr_job_step_state_flags {
	LLR_JOB_STEP_REJECTED = (1<<0)
} llr_job_step_state_flags_t;
typedef enum llr_adapter_state {
	LLR_READY,
	LLR_ErrNotConnected,
	LLR_ErrNotInitialized,
	LLR_ErrNTBL,
	LLR_ErrNRT,
	LLR_ErrAdapter,
	LLR_ErrInternal,
	LLR_ErrPerm,
	LLR_ErrPNSD,
	LLR_ErrDown,
	LLR_ErrType,
	LLR_ErrNTBLVersion,
	LLR_ErrNRTVersion,
	LLR_ErrNotConfigured,
	LLR_Unknown
}llr_adapter_state_t;

typedef enum llr_heartbeat_status {
	LLR_HB_UNKNOWN,
	LLR_HB_UP,
	LLR_HB_DOWN,
	LLR_HB_REGION_DOWN
} llr_heartbeat_status_t;

typedef void llr_resmgr_handle_t;
typedef void llr_element_t;
typedef void llr_query_handle_t;

typedef struct llr_data_list {
	llr_element_t *data;
	llr_element_t *cursor;
} llr_data_list_t;

typedef struct llr_job_info {
	llr_job_format_t format;
	llr_job_mode_t mode;
	char *job_description;
	char *scheduler_id;
} llr_job_info_t;

typedef struct llr_network_usage {
	uint64_t network_id;
	int instances;
	int window_count;
	int adapter_memory;
	char *protocol;
	llr_network_mode_t mode;
	llr_network_type_t network_type;
} llr_network_usage_t;

typedef struct llr_task_data {
	int task_id;
	int cpu_count;
	int *cpu_list;
} llr_task_data_t;

typedef struct llr_machine_data {
	char *machine_name;
	int task_count;
	llr_task_data_t *task_list;
} llr_machine_data_t;

typedef struct llr_job_step_resouce {
	int machine_count;
	llr_machine_data_t *machine_list;
	int network_usage_count;
	llr_network_usage_t *network_usage_list;
	char *bg_partition;
} llr_job_step_resource_t;

typedef struct llr_job_step_opts {
	llr_job_start_flags_t flags;
} llr_job_step_opts_t;

typedef struct llr_event_registration {
	int port;
	char *scheduler_id;
} llr_event_registration_t;

typedef struct llr_event {
	llr_event_type_t event_type;
	void *event_data;
} llr_event_t;

typedef struct llr_state_change_event_data {
	llr_step_state_t job_step_state;
	unsigned int job_step_state_flags;
	char *job_step_id;
	char *rejecting_machine;
	struct rusage64 *job_step_usage;
	time_t completion_date;
	int completion_code;
} llr_state_change_event_data_t;

typedef struct llr_jobid_change_event_data {
	char *old_job_id;
	char *new_job_id;
	char *new_job_mgr;
	char **oldSteplist;	/* NULL terminated */
	char **newSteplist;	/* NULL terminated */
} llr_jobid_change_event_data_t;

typedef struct llr_query_filter {
	llr_query_filter_type_t filter_type;
	char **filter_data;
} llr_query_filter_t;

typedef struct llr_move_spool_param {
	char **schedd_host;
	char *spool_directory;
	llr_move_spool_data_t data;
} llr_move_spool_param_t;

typedef struct llr_cluster_auth_param {
	llr_cluster_auth_op_t op;
} llr_cluster_auth_param_t;

/***********************************************************************
 * Support for llr_config API
 **********************************************************************/
enum LLR_config_op { R_CONFIG_I, R_CONFIG_C, R_CONFIG_D };

#define LLRCONFIG_INITIALIZE_OK 0
#define LLRCONFIG_CHANGE_OK 0
#define LLRCONFIG_DISPLAY_OK 0
#define LLRCONFIG_DB_CANNOT_CONNECT -1
#define LLRCONFIG_INITIALIZE_RUN_SQL_ERROR -2
#define LLRCONFIG_CHECK_FAILED -3
#define LLRCONFIG_INITIALIZE_PUT_TO_DB_ERROR -4
#define LLRCONFIG_INITIALIZE_CM_NEEDED -5
#define LLRCONFIG_INITIALIZE_SCHEDD_NEEDED -6
#define LLRCONFIG_CHANGE_AUTH_FAILED -7
#define LLRCONFIG_CHANGE_RECONFIG_ERROR -8
#define LLRCONFIG_NOT_VALID_INPUT -9
#define LLRCONFIG_LOAD_ODBC_LIBRARY_FAILED -10
#define LLRCONFIG_LOADLDB_NOT_CONFIG -11
#define LLRCONFIG_CONFIG_OPT_UNSUPPORTED -12
#define LLRCONFIG_INITIALIZE_PARSE_FILE_FAILED -13
#define LLRCONFIG_NO_UPDATE_NEEDED -14

#ifdef __cplusplus
extern "C" {
#endif

	/* Resource manager setup API           */
	int llr_init_resmgr(int, llr_resmgr_handle_t **, llr_element_t **);
	int llr_free_resmgr(llr_resmgr_handle_t **, llr_element_t **);
	int llr_version_resmgr(void);

	/* Resource manager job management API  */
	int llr_add_job(llr_resmgr_handle_t *, llr_job_info_t *,
	                llr_element_t **, llr_element_t **);
	int llr_start_job_step(llr_resmgr_handle_t *, const char *,
	                       llr_job_step_resource_t *, llr_job_step_opts_t *,
	                       llr_element_t **);
	int llr_control_job(llr_resmgr_handle_t *, const char *, llr_job_control_op_t, void *,
	                    llr_element_t **);
	int llr_delete_job(llr_resmgr_handle_t *, const char *, llr_element_t **);
	int llr_free_job(llr_resmgr_handle_t *, llr_element_t **,
	                 llr_element_t **);

	/* Resource manager event handling API  */
	int llr_register_for_events(llr_resmgr_handle_t *,
	                            llr_event_registration_t *, llr_element_t **);
	int llr_read_events(llr_resmgr_handle_t *, llr_element_t **);
	int llr_get_event(llr_resmgr_handle_t *, llr_event_t **event_data,
	                  llr_element_t **);
	int llr_free_event(llr_resmgr_handle_t *, llr_event_t **,
	                   llr_element_t **);
	int llr_unregister_for_events(llr_resmgr_handle_t *,
	                              llr_event_registration_t *, llr_element_t **);
	int llr_get_event_fd (llr_resmgr_handle_t *);

	/* Resource manager data access API     */
	int llr_query_set(llr_resmgr_handle_t *, llr_query_handle_t **,
	                  llr_query_type_t,  int, llr_query_filter_t *, llr_element_t **);
	int llr_query_get_data(llr_resmgr_handle_t *,  llr_query_handle_t *,
	                       llr_query_source_t, const char *, llr_element_t ***, llr_element_t **);
	int llr_query_free_data(llr_resmgr_handle_t *, llr_query_handle_t **,
	                        llr_element_t **);
	int llr_get_data(llr_resmgr_handle_t *, llr_element_t *,
	                 llr_data_specification_t, void*, llr_element_t **);

	/* Resource manager accounting API      */
	int llr_get_history(llr_resmgr_handle_t  *, const char *,
	                    int (*func) (llr_element_t *),  llr_element_t **);

	/* Resource manager cluster control API */
	int llr_cluster_auth (int, llr_cluster_auth_param_t **,
	                      llr_element_t **);
	int llr_control(llr_resmgr_handle_t *, llr_control_op_t, char **,
	                llr_element_t **);
	int llr_move_spool(llr_resmgr_handle_t *, llr_move_spool_param_t **,
	                   int (*func) (char *, int, llr_element_t **), llr_element_t **);

	/* Resource manager error handling API  */
	char *llr_error (llr_element_t **, llr_error_opt_t);

	int llr_config(int version, enum LLR_config_op config_op, char **input, char ***output, char **hostlist, llr_element_t **err_obj);


#ifndef CKPT_DATA
#define CKPT_DATA
	typedef enum ckpt_type {CKPT_AND_CONTINUE, CKPT_AND_TERMINATE, CKPT_AND_HOLD} CkptType_t;
	typedef enum wait_option {CKPT_NO_WAIT, CKPT_WAIT} WaitOption_t;


#endif

	typedef struct LLR_ckpt_info {
		int             version;	/* version of the api compiled with */
		char            *step_id;	/* id of step being checkpointed    */
		enum ckpt_type  ckptType;	/* action after success     */
		enum wait_option waitType;	/* identify if blocking enabled */
		int             abort_sig;	/* signal to abort ckpt, default is SIGINT*/
		int		ckpt_rc; 	/* return code from checkpnt()	    */
		int             soft_limit;	/* ckpt soft time limit, in seconds */
		int             hard_limit;	/* ckpt hard time limit, in seconds */
	}LLR_ckpt_info;

	int llr_ckpt(LLR_ckpt_info *, char *);
#ifdef __cplusplus
}
#endif /* __cpluplus */

#endif /* _llrapi_h__ */
