#
#	Machine Description
#
# ARCH = PPC64

#
#  Specify LoadLeveler Administrators here:
#
LOADL_ADMIN = loadl	

#
#	Default to starting LoadLeveler daemons when requested
#
START_DAEMONS = TRUE

#
#	Machine authentication
#
#	If TRUE, only connections from machines in the ADMIN_LIST are accepted.
#	If FALSE, connections from any machine are accepted.  Default if not
#	specified is FALSE.
#
MACHINE_AUTHENTICATE = FALSE

#
# Specify resource managers and their back ups.
#       The first machine listed is the resource manager and
#       any additional machines are alternate managers.
#
# RESOURCE_MGR_LIST = Mach1 Mach2

#
# Specify information for backup resource managers
#
# FAILOVER_HEARTBEAT_INTERVAL = 300
# FAILOVER_HEARTBEAT_RETRIES = 6

#
# Specify pathnames
#
# RELEASEDIR contains the directory path to where the loadl binaries are
#
RELEASEDIR      = /opt/ibmll/LoadL/resmgr/full
ADMIN_FILE      = $(RELEASEDIR)/samples/LoadL_admin.l
LOG	        = /var/loadl/log
SPOOL	        = /var/loadl/spool
EXECUTE		= /var/loadl/execute
HISTORY		= $(SPOOL)/history
RESERVATION_HISTORY = $(SPOOL)/reservation_history
BIN		= $(RELEASEDIR)/bin

#
# Specify port numbers
#
MASTER_STREAM_PORT     = 9616
REGION_MGR_STREAM_PORT = 9680
RESOURCE_MGR_STREAM_PORT = 9618
SCHEDD_STREAM_PORT     = 9605
STARTD_STREAM_PORT     = 9611

STARTD_DGRAM_PORT      = 9615
MASTER_DGRAM_PORT      = 9617
REGION_MGR_DGRAM_PORT  = 9682
RESOURCE_MGR_DGRAM_PORT = 9619


#
# Specify accounting controls
# To turn reservation data recording on, add the flag A_RES to ACCT
#
ACCT 			= A_OFF A_RES
#ACCT_VALIDATION	= $(BIN)/llacctval
GLOBAL_HISTORY		= $(SPOOL)

#
# Specify prolog and epilog path names
#
# JOB_PROLOG = 
# JOB_EPILOG = 
# JOB_USER_PROLOG = 
# JOB_USER_EPILOG =

#
# Refresh AFS token program.
# 
# AFS_GETNEWTOKEN = 

#
# Customized mail delivery program.
# 
# MAIL = 

#
# Specify checkpointing intervals
#
# MIN_CKPT_INTERVAL    = 900
# MAX_CKPT_INTERVAL    = 7200

# perform cleanup of checkpoint files once a day            
# 24 hrs x 60 min/hr x 60 sec/min = 86400 sec/day
 
# CKPT_CLEANUP_INTERVAL = 86400


# sample source for the ckpt file cleanup program is shipped with LoadLeveler
# and is found in:  /opt/ibmll/LoadL/scheduler/full/samples/llckpt/rmckptfiles.c
#
# compile the source and indicate the location of the executable 
# as shown in the following example

# CKPT_CLEANUP_PROGRAM = /u/mylladmin/bin/rmckptfiles

#	LoadL_KeyboardD Macros
#
KBDD                = $(BIN)/LoadL_kbdd
KBDD_LOG            = $(LOG)/KbdLog
MAX_KBDD_LOG        = 64000
#KBDD_DEBUG          =

# 
# Specify whether to start the keyboard daemon
#
X_RUNS_HERE			= False

#
#		LoadL_StartD Macros
#
STARTD			   = $(BIN)/LoadL_startd
STARTD_LOG		   = $(LOG)/StartLog
MAX_STARTD_LOG	 	   = 64000
#STARTD_DEBUG		   =
POLLING_FREQUENCY	   = 5
POLLS_PER_UPDATE	   = 24
JOB_LIMIT_POLICY	   = 120
JOB_ACCT_Q_POLICY 	   = 300
PROCESS_TRACKING	   = FALSE
#PROCESS_TRACKING_EXTENSION = $(BIN)

#DRAIN_ON_SWITCH_TABLE_ERROR = false
#RESUME_ON_SWITCH_TABLE_ERROR_CLEAR = false


#
#		LoadL_SchedD Macros
#
SCHEDD			= $(BIN)/LoadL_schedd
SCHEDD_LOG		= $(LOG)/SchedLog
MAX_SCHEDD_LOG		= 64000
#SCHEDD_DEBUG		=
SCHEDD_INTERVAL		= 120

CLIENT_TIMEOUT		= 30

MACHINE_UPDATE_INTERVAL = 300

#
#	Resource Manager Macros
#
RESOURCE_MGR		        = $(BIN)/LoadL_resource_mgr
#RESOURCE_MGR_DEBUG		=
RESOURCE_MGR_LOG		= $(LOG)/ResourceManagerLog
MAX_RESOURCE_MGR_LOG	        = 64000
RESOURCE_MGR_COREDUMP_DIR 	= /tmp

#
# Consumable Resources
#

# WLM can be used to enforce resource usage for ConsumableCpus and/or
# for ConsumableMemory
#
# or by specifying deactivate, WLM will be deactivated on all nodes in the
# LoadLeveler cluster
# ENFORCE_RESOURCE_USAGE = ConsumableCpus

# When ENFORCE_RESOURCE_USAGE is set, the way enforcement is done is specified
# using ENFORCE_RESOURCE_POLICY.  The policies available are hard, soft,
# and shares.
# ENFORCE_RESOURCE_POLICY = shares

# FLOATING_RESOURCES = FloatingLicenseX(5) FloatingLicenseZ(2)

#
# Starter Macros
#
STARTER			= $(BIN)/LoadL_starter
#STARTER_DEBUG		= 
STARTER_LOG             = $(LOG)/StarterLog
MAX_STARTER_LOG         = 64000

#
# LoadL_Master Macros
#
MASTER			= $(BIN)/LoadL_master
MASTER_LOG		= $(LOG)/MasterLog
#MASTER_DEBUG		=
MAX_MASTER_LOG		= 64000
RESTARTS_PER_HOUR	= 12
PUBLISH_OBITUARIES	= TRUE
OBITUARY_LOG_LENGTH	= 25

#
#   Region Manager Macros
#
#REGION_MGR        = $(BIN)/LoadL_region_mgr
#REGION_MGR_DEBUG      = D_REGIONMGR
#REGION_MGR_LOG        = $(LOG)/RegionMgrLog
#MAX_REGION_MGR_LOG    = 64000
#REGION_MGR_COREDUMP_DIR   = /tmp

# Specify settings for the heartbeat between the region manager and the startd
#
#ADAPTER_HEARTBEAT_INTERVAL = 30
#ADAPTER_HEARTBEAT_RETRIES = 2
#ADAPTER_HEARTBEAT_PORT = 9684

#
# Specify whether log files are truncated when opened
#
TRUNC_MASTER_LOG_ON_OPEN     = False
TRUNC_STARTD_LOG_ON_OPEN     = False
TRUNC_SCHEDD_LOG_ON_OPEN     = False
TRUNC_KBDD_LOG_ON_OPEN       = False
TRUNC_STARTER_LOG_ON_OPEN    = False
TRUNC_REGION_MGR_LOG_ON_OPEN = False
TRUNC_RESOURCE_MGR_LOG_ON_OPEN = False

#
# Specify Machine's relative priority to run jobs.
#
# CUSTOM_METRIC		=
# CUSTOM_METRIC_COMMAND	= 

#
#	Expressions used to control starting and stopping of foreign jobs
#
MINUTE		= 60
HOUR		= (60 * $(MINUTE))
StateTimer	= (CurrentTime - EnteredCurrentState)

BackgroundLoad		= 0.7
HighLoad		= 1.5
StartIdleTime		= 15 * $(MINUTE)
ContinueIdleTime	= 5 * $(MINUTE)
MaxSuspendTime		= 10 * $(MINUTE)
MaxVacateTime		= 10 * $(MINUTE)

KeyboardBusy	= KeyboardIdle < $(POLLING_FREQUENCY)
CPU_Idle	= LoadAvg <= $(BackgroundLoad)
CPU_Busy	= LoadAvg >= $(HighLoad)

#
#  See Using and Administering LoadLeveler for an explanation of these 
#  control expressions
#
# SUSPEND	: $(CPU_Busy) || $(KeyboardBusy)
# CONTINUE	: $(CPU_Idle) && KeyboardIdle > $(ContinueIdleTime)
# VACATE	: $(StateTimer) > $(MaxSuspendTime)
# KILL		: $(StateTimer) > $(MaxVacateTime)

SUSPEND		: F
CONTINUE	: T
VACATE		: F
KILL		: F

#
# The REJECT_ON_RESTRICTED_LOGIN specifies if the user's AIX login status 
#	should be checked to determine if the user is locked out. 
#	REJECT_ON_RESTRICTED_LOGIN may only be specified in the global 
#	configuration file. Valid values are TRUE or FALSE.  FALSE is the 
#	default which indicates that no AIX login restriction check is to be 
#	performed. TRUE specifies that the AIX login restriction check is to be 
#	performed on every node the job is scheduled to run on. If the user 
#	has been locked out on any of these nodes then the job will be rejected. 
#
REJECT_ON_RESTRICTED_LOGIN = FALSE

#
# To specify the security method used, set SEC_ENABLEMENT to COMPAT, DCE,
# or CTSEC. The default security method is COMPAT. When SEC_ENABLEMENT=CTSEC
# or SEC_ENABLEMENT=DCE the SEC_ADMIN_GROUP and the SEC_SERVICES_GROUP must
# also be specified. See Using and Admin Guide for a description of setting
# these keywords when DCE or CTSEC are enabled.
# 
#SEC_ENABLEMENT=CTSEC
#SEC_ADMIN_GROUP=LoadL-admin
#SEC_SERVICES_GROUP=LoadL-services
#
# When SEC_ENABLEMENT=CTSEC, you can specify SEC_IMPOSED_MECHS.
# SEC_IMPOSED_MECHS identifies the security mechanism which may be used
# by LoadLeveler for authentication. This should be used if LoadLeveler is
# restricted to using a subset of authentication methods for which machines 
# in your cluster are configured.  The mechanisms available to LoadLeveler
# are none and unix.
# none indicates users can run unauthenticated, although if authorization
# is required this will fail.
# unix indicates that Unix host-based authentication can be used.
#
#SEC_IMPOSED_MECHS=none unix
#
# The default DCE_AUTHENTICATION_PAIR used when SEC_ENABLEMENT is
# specified as DCE is shown below.  If you wish to use the default
# you may leave DCE_AUTHENTICATION_PAIR commented out, or uncomment
# the following line.
#
#DCE_AUTHENTICATION_PAIR = $(BIN)/lldelegate, $(BIN)/llimpersonate
#
# To enable LoadLeveler to support DCE security credential passing 
# when SEC_ENABLEMENT is not set to DCE, uncomment the following 
# keyword. You may also choose to uncomment the following line when
# DCE_ENABLEMENT is specified as DCE to overrride the default
# DCE_AUTHENTICATION_PAIR.
# 
# An installation can provide its own executables to pass or establish DCE
# security credentials for a LoadLeveler job by replacing the executables 
# specified by DCE_AUTHENTICATION_PAIR.
#
#DCE_AUTHENTICATION_PAIR = $(BIN)/llgetdce, $(BIN)/llsetdce
#

# Filesystem Monitor Interval and Threshholds 

# Monitoring Interval is in minutes and should be set according to how
# Fast the filesystem grows
# FS_INTERVAL = 30

# Threshholds are specified in low,high pairs.  When the value being
# monitored goes below the low value, the action is taken (eg. the
# administrator is notified of a problem or LoadLeveler is suspended or
# terminated).  When the value being monitored rises above the high
# threshhold after being below the low threshhold, the complementary
# action is taken -- the administrator is notified that the problem
# has been resolved or LoadLeveler is resumed.  LoadLeveler is not
# restarted if it is terminated because the 'Terminate' action
# was taken.

# File System space threshholds are specified in Bytes.  Scaling factors
# such as K, M and G are allowed.
# FS_NOTIFY       = 750KB,1MB
# FS_SUSPEND      = 500KB, 750KB
# FS_TERMINATE    = 100MB,100MB

# File System inode threshholds are specified in number of inodes.  Scaling factors
# such as K, M and G are allowed.
# INODE_NOTIFY    = 1K,1.1K
# INODE_SUSPEND   = 500,750
# INODE_TERMINATE = 50,50

