/*
 * ------------------------------------------------------------------------
 * Sample program calling the llr_cluster_auth function
 * -------------------------------------------------------------------------
 */
static char llrclusterauth_sccsid[] = "@(#) src/ll/samples/llrclusterauth/llrclusterauth.c, ll.api, ll_rrur2, rrur2s002a 1.3 12/14/10 10:43:21";

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include "llrapi.h" 

#ifdef __linux__
char auth[4][256] = {"/var/opt/LoadL/ssl/id_rsa", "/var/opt/LoadL/ssl/id_rsa.pub", "/var/opt/LoadL/ssl/id_rsa.cert", "/var/opt/LoadL/ssl/authorized_keys"};
#else
char auth[4][256] = {"/var/LoadL/ssl/id_rsa", "/var/LoadL/ssl/id_rsa.pub", "/var/LoadL/ssl/id_rsa.cert", "/var/LoadL/ssl/authorized_keys"};
#endif

int main(int argc, char * argv[]) {
	int error = 0;
	int llr_version = LLR_API_VERSION;
	llr_cluster_auth_param_t * param;
	llr_element_t *errObj = NULL;
	int rc = -1;
	int j;

	if(getuid() != 0) {
		printf("This program must be run by root!\n");
		exit(1);
	}

	param = (llr_cluster_auth_param_t *) malloc(sizeof(llr_cluster_auth_param_t ) * 1);
	param->op = LLR_CLUSTER_AUTH_GENKEY;

#ifdef __linux__
	system("rm -r /var/opt/LoadL/ssl");
#else
	system("rm -r /var/LoadL/ssl");
#endif

	rc = llr_cluster_auth(llr_version, &param, &errObj);
	if (rc != LLR_API_OK) {
		llr_error(&errObj, LLR_ERROR_PRINT_STDERR);
		error=1;
	} 

	for (j = 0; j < 4; j++) {
		if(access(auth[j], F_OK)) {
			printf("File \"%s\" does not exist!\n", auth[j]);
			error=1;
		}else {
			printf("File \"%s\" is created successfully. \n", auth[j]);
		}
	}
	return error;
}
