/*
 * ------------------------------------------------------------------------
 * Read a job history file and show the job IDs and number of steps
 * -------------------------------------------------------------------------
 */
static char llrsummary_sccsid[] = "@(#) src/ll/samples/llrsummary/llrsummary.c, ll.api, ll_rrur2, rrur21042a 1.2 3/17/10 03:45:23";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "llrapi.h"

llr_resmgr_handle_t *rm_handle = NULL;
int	getjobinfo(llr_element_t *job) {
	llr_element_t *err_object = NULL;
	int rc = 0;
	int step_count = 0;
	char *job_id;
	rc = llr_get_data(rm_handle, job, LLR_JobID, &job_id, &err_object);
	rc += llr_get_data(rm_handle, job, LLR_JobStepCount, &step_count, &err_object);
	if (rc != LLR_API_OK) {
		if (err_object) {
			llr_error(&err_object, LLR_ERROR_PRINT_STDERR);
		}
		fprintf(stderr, "llr_get_data failed.\n");
		return(-1);
	} else {
		fprintf(stdout, "Job %s has %d %s.\n", job_id, step_count, step_count==1?"step":"steps");
		return 0;
	}
}

main(int argc, char *argv[])
{
	llr_element_t *errObj = NULL;
	int ret;

	if (argc < 2 ) {
		printf("Usage: %s <history_file>\n", argv[0]);
		exit(1);
	}
	*argv++;

	if (*argv) {
		ret = llr_init_resmgr(LLR_API_VERSION, &rm_handle, &errObj);
		if (ret != LLR_API_OK ) {
			llr_error(&errObj, LLR_ERROR_PRINT_STDOUT);
			return ret;
		}
		
		ret = llr_get_history( rm_handle, *argv, getjobinfo, &errObj);
		if (ret != LLR_API_OK) {
			llr_error(&errObj, LLR_ERROR_PRINT_STDOUT);
			return 2;
		}

		llr_free_resmgr(&rm_handle, &errObj);
		if (ret != LLR_API_OK) {
			printf("error\n");
			llr_error(&errObj, LLR_ERROR_PRINT_STDOUT);
			return 2;
		}
	} 

	exit(0);
}


